library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;

library unisim;
use unisim.vcomponents.all;

entity Div3 is
    Port ( I : in std_logic;
           O : out std_logic);
end div3;

architecture RTL of Div3 is

signal A, B, AB, CO: std_logic;

begin

	O <= CO;

	ff1: FD port map (C => I, D => AB, Q => A);
	ff2: FD port map (C => I, D => A, Q => B);

	AB <= (not A) and (not B);
	CO <= (A or CO) and (I or not B);

end RTL;
